using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace BG_3D
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;
        GameObject terrain = new GameObject();//浵 Ʈ մϴ.
        GameObject missileLauncherBase = new GameObject();//̻ϰġ
        GameObject missileLauncherHead = new GameObject();//̻
        GameObject[] missile;//̻ 迭 Ͻð
        const int maxmissile = 10;//ִ ̻  
        const float misailepow = 20.0f;//̻ ǵ
        KeyboardState previousState;//ӹ Ű
        Vector3 cameraPosition = new Vector3(0.0f, 60.0f, 160.0f);
        Vector3 cameraLookAt = new Vector3(0.0f, 50.0f, 0.0f);
        Matrix cameraProjectionMatrix;
        Matrix cameraViewMatrix;
        Random r = new Random();// ϰ ö  r
        const int numEnemyShips = 3;// 
        GameObject[] enemyShips;// 
        Vector3 shipMinPosition = new Vector3(-2000.0f, 300.0f, -6000.0f);
        // ġ ּ
        Vector3 shipMaxPosition = new Vector3(2000.0f, 800.0f, -4000.0f);
        // ġ ִ
        const float shipMinVelocity = 5.0f;
        //̵ӵ ִ
        const float shipMaxVelocity = 10.0f;
        //̵ӵ ּ
        AudioEngine AudioEngine;//Ʈ
        WaveBank WaveBank;//̺ũִ
        SoundBank SoundBank;//̺ Ҽ ִ 
        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here

            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);
            cameraViewMatrix = Matrix.CreateLookAt(
                cameraPosition,
                cameraLookAt,
                Vector3.Up);

            cameraProjectionMatrix = Matrix.CreatePerspectiveFieldOfView(
                MathHelper.ToRadians(45.0f),
                graphics.GraphicsDevice.Viewport.AspectRatio,
                1.0f,
                10000.0f);
            //ε  ӿƮ Ŭ 缭 մϴ//
            AudioEngine = new AudioEngine("Content\\Audio\\TutorialAudio.xgs");
            WaveBank = new WaveBank(AudioEngine, "Content\\Audio\\Wave Bank.xwb");
            SoundBank = new SoundBank(AudioEngine, "Content\\Audio\\Sound Bank.xsb");
            terrain.model = Content.Load<Model>(
                "Models\\terrain");
            missileLauncherBase.model = Content.Load<Model>(
                "Models\\launcher_base");
            missileLauncherBase.scale = 0.2f;
            missileLauncherHead.model = Content.Load<Model>(//̻ҷ
                "Models\\launcher_head");
            missileLauncherHead.scale = 0.2f;//ũ
            missileLauncherHead.position = missileLauncherBase.position +
                new Vector3(0.0f, 20.0f, 0.0f);//ġ ־ y20
            missile = new GameObject[maxmissile];//̻Ϲ迭 ʱȭ
            for (int i = 0; i < maxmissile; i++)//̻ϼŭ 𵨷ε
            {
                missile[i] = new GameObject();
                missile[i].model = Content.Load<Model>("Models\\missile");
                missile[i].scale = 3.0f;
            }
            enemyShips = new GameObject[numEnemyShips];
            for (int i = 0; i < numEnemyShips; i++)
            {
                enemyShips[i] = new GameObject();
                enemyShips[i].model = Content.Load<Model>(
                    "Models\\enemy");
                enemyShips[i].scale = 0.1f;//ũ⼳
                enemyShips[i].rotation = new Vector3(//ּ⼳
                    0.0f, MathHelper.Pi, 0.0f);
            }
            // TODO: use this.Content to load your game content here
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();
            KeyboardState KeyboardState = Keyboard.GetState();//Ű
            if(KeyboardState.IsKeyDown(Keys.Left)){
                missileLauncherHead.rotation.X += 0.01f;
            }
             if(KeyboardState.IsKeyDown(Keys.Right)){
                missileLauncherHead.rotation.X -= 0.01f;
            }
             if(KeyboardState.IsKeyDown(Keys.Up)){
                missileLauncherHead.rotation.Y += 0.01f;
            }
             if(KeyboardState.IsKeyDown(Keys.Down)){
                missileLauncherHead.rotation.Y -= 0.01f;
            }
            missileLauncherHead.rotation.Y = MathHelper.Clamp(//̻ Y 45 
                missileLauncherHead.rotation.Y, 0, MathHelper.PiOver4);
            missileLauncherHead.rotation.X = MathHelper.Clamp(//̻ X 90 
                missileLauncherHead.rotation.X, -MathHelper.PiOver4, MathHelper.PiOver4);


            if (KeyboardState.IsKeyDown(Keys.Space) && previousState.IsKeyUp(Keys.Space))
            {
                Firemissaile();//̻ ߻Լ
            }
            previousState = KeyboardState;//ѹ ٳ ͹
            UpdateEnemyShips();
            updat();
            AudioEngine.Update(); //  Žð ɴϴ.
            // TODO: Add your update logic here

            base.Update(gameTime);
        }
        void Firemissaile()//̻̾ Լ
        {
            foreach (GameObject misaile in missile)//̻ ŭ
            {
                if (!misaile.alive)//̻ ߻ ʾҴٸ!
                {
                    SoundBank.PlayCue("missilelaunch");//
                    misaile.alive = true;// ̵
                    misaile.position = getmisailposition();//̻ ġ
                    misaile.verocity = getmisailverocity();//̻ ̵ ǥ
                    misaile.rotation = missileLauncherHead.rotation;//̻ 
                    break;
                }
            }

        }
        Vector3 getmisailverocity()//̻ ̵ ǥ
        {
            Matrix verocity =//Ʈ ̵ǥ = ̻ X,Yǥ
                Matrix.CreateFromYawPitchRoll(missileLauncherHead.rotation.X,
                missileLauncherHead.rotation.Y, 0);
            return Vector3.Normalize(Vector3.Transform(Vector3.Forward, verocity)) * misailepow;
            //մϴ XYǥ ̻ Ŀŭ ǥ̵ 

        }
        Vector3 getmisailposition()//̻ ġ
        {
            return missileLauncherHead.position + Vector3.Normalize(getmisailverocity());
            //Ѵ ̻Ϸó ġ Ѵ ̻ ̵ǥŭ
        }
        void updat()//̵̻
        {
            foreach (GameObject misaile in missile)
            {
                if (misaile.alive)// ̻ ߻Ǿٸ
                {
                    misaile.position += misaile.verocity;
                    if (misaile.position.Z < -6000.0f)//6000̳ 
                    {
                        misaile.alive = false;
                    }
                    else
                    {
                        Testcolletion(misaile);//Լ ȣ
                    }
                }
            }
        }
        void Testcolletion(GameObject missile)//浹üũ Լ
        {
            BoundingSphere misailesphere = missile.model.Meshes[0].BoundingSphere;
            //3DRectangle BoundingSphere մϴ 3D Դϴ.
            misailesphere.Center = missile.position;
            //Ǿ ġԴϴ. 翬 ̻ġ
            misailesphere.Radius *= missile.scale;
            // Դϴ. ũ⸸ŭ Ǿ߰
            if (missile.alive)//̻ ߻Ǿٸ
            {
                foreach (GameObject enemy in enemyShips)// 
                {
                    BoundingSphere enemysphere = enemy.model.Meshes[0].BoundingSphere;
                    enemysphere.Center = enemy.position;
                    enemysphere.Radius *= enemy.scale;
                    if (enemysphere.Intersects(misailesphere))//浹üũ
                    {
                        SoundBank.PlayCue("explosion");
                        missile.alive = false;//
                        enemy.alive = false;//
                        break;
                    }
                }
            }
        }

        void UpdateEnemyShips()//̵
        {
            foreach (GameObject ship in enemyShips)
            {
                if (ship.alive)
                {
                    ship.position += ship.verocity;
                    if (ship.position.Z > 500.0f)
                    {
                        ship.alive = false;
                    }
                }
                else
                {
                    ship.alive = true;
                    ship.position = new Vector3(
                        MathHelper.Lerp(
                        shipMinPosition.X,
                        shipMaxPosition.X,
                        (float)r.NextDouble()),

                        MathHelper.Lerp(
                        shipMinPosition.Y,
                        shipMaxPosition.Y,
                        (float)r.NextDouble()),

                        MathHelper.Lerp(
                        shipMinPosition.Z,
                        shipMaxPosition.Z,
                        (float)r.NextDouble()));


                    ship.verocity = new Vector3(
                        0.0f,
                        0.0f,
                        MathHelper.Lerp(shipMinVelocity,
                        shipMaxVelocity, (float)r.NextDouble()));
                }
            }
        }
            /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            graphics.GraphicsDevice.Clear(Color.CornflowerBlue);
            foreach (GameObject misaile in missile)
            {
                if (misaile.alive)
                {
                    DrawGameObject(misaile);
                }
            }
            DrawGameObject(terrain);
            DrawGameObject(missileLauncherBase);
            DrawGameObject(missileLauncherHead);
            foreach (GameObject enemyship in enemyShips)
            {
                if (enemyship.alive)
                {
                    DrawGameObject(enemyship);
                }
            }
            // TODO: Add your drawing code here

            base.Draw(gameTime);
        }

        void DrawGameObject(GameObject gameobject)
        {
            foreach (ModelMesh mesh in gameobject.model.Meshes)
            {
                foreach (BasicEffect effect in mesh.Effects)
                {
                    effect.EnableDefaultLighting();
                    effect.PreferPerPixelLighting = true;

                    effect.World =
                        Matrix.CreateFromYawPitchRoll(
                        gameobject.rotation.X,
                        gameobject.rotation.Y,
                        gameobject.rotation.Z) *
                        Matrix.CreateScale(gameobject.scale) *
                        Matrix.CreateTranslation(gameobject.position);

                    effect.Projection = cameraProjectionMatrix;
                    effect.View = cameraViewMatrix;
                }
                mesh.Draw();
            }
        }
    }
}
